<?php
  /* RDBMS Smarttable.
   Copyright (C) 2005, 2006, 2007 David Englund.

   This file is part of GNU Sovix.

   GNU Sovix is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GNU Sovix is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Sovix; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

  /*
   ** Tables used in this test are:


   Postgres 7.4
   CREATE TABLE sovix (boolean boolean, char_255 char(255), date date, int_10 integer, time time, varchar_255 varchar(255));
   BEGIN; ALTER TABLE sovix ADD id INTEGER; CREATE SEQUENCE sovix_id_seq; ALTER TABLE sovix ALTER id SET DEFAULT NEXTVAL('sovix_id_seq'); UPDATE sovix SET id = NEXTVAL('sovix_id_seq'); ALTER TABLE sovix ALTER id SET NOT NULL; ALTER TABLE sovix ADD PRIMARY KEY (id); COMMIT;

   MySQL 4.1
   CREATE TABLE sovix (boolean BOOLEAN, char_255 char(255), date DATE, int_10 INT(10), time TIME, varchar_255 VARCHAR(255)); ALTER TABLE sovix ADD id INT AUTO_INCREMENT PRIMARY KEY;

   Notes:
   ** PostgreSQL use t/f for boolean and MySQL 0/1
   */

if($database_server=="postgresql") $fetch_array="pg_fetch_array";
elseif($database_server=="mysql") $fetch_array="mysql_fetch_array";

$id = $_POST['id']; $_SESSION['id']=$id;
$action = $_POST['action']; $_SESSION['action']=$action;
$quicksearch = $_POST['quicksearch']; $_SESSION['quicksearch']=$quicksearch;
$new = $_POST['new']; $_SESSION['new']=$new;

if($database_server=="postgresql") {
  if(!empty($port)) $port="port=$port";
  $dbconn = pg_connect("host=$host $port dbname=$dbname user=$user password=$password") or die('Could not connect: ' . pg_last_error());
 }
elseif($database_server=="mysql") {
  if(!empty($port)) $port=":$port";
  $link = mysql_connect("$host$port", $user, $password);
  if (!$link) {
    die('Not connected : ' . mysql_error());
  }
  $db_selected = mysql_select_db("$dbname", $link);
  if (!$db_selected) {
    die ('Can\'t use foo : ' . mysql_error());
  }
}

/*********************************************************************************************/
if ($action=="search") {

  echo "<ul>";
  for($i = 0; $i < count($list); $i++) if ("{$list[$i]['dbtype']}"!="id" && "{$list[$i]['private']}"=="n") {
      {
	if($database_server=="postgresql") {
	  ${$list[$i]['x']}=pg_escape_string(stripslashes($_POST["{$list[$i]['x']}"]));
	  $sometext[$list[$i]['x']]=pg_escape_string(stripslashes($_POST["op_{$list[$i]['x']}"]));
	}
	elseif($database_server=="mysql") {
	  ${$list[$i]['x']}=mysql_escape_string(stripslashes($_POST["{$list[$i]['x']}"]));
	  $sometext[$list[$i]['x']]=mysql_escape_string(stripslashes($_POST["op_{$list[$i]['x']}"]));
	}
	if (${$list[$i]['x']}!="" && $sometext[$list[$i]['x']]=="empty") { echo "<li>{$list[$i]['y']} <span style=\"color:red;\">(condition not set)</span></li>"; $complete="n"; }
	if(${$list[$i]['x']}!="" && "{$list[$i]['dbtype']}"=="date" && strlen(${$list[$i]['x']})!="10" || ${$list[$i]['x']}!="" && "{$list[$i]['dbtype']}"=="time" && strlen(${$list[$i]['x']})!="8") { print"  <li>{$list[$i]['y']} <span style=\"color:red;\">(wrong format)</span></li>"; $complete="n";
	}
	if(${$list[$i]['x']}!="") $rows="set";
	echo "</li>";
      }
    }
  echo "</ul>";
  if ($complete!="n" && $rows="set") {
    echo "<form method=\"post\">";
    if ($new=="y") {
      echo "
<input type=\"hidden\" name=\"action\" value=\"insertnew\" />
<input value=\"Go back\" type=\"submit\" />";
    }
    elseif ($action=="insert") {
      echo "
<input type=\"hidden\" name=\"id\" value=\"$id\" />
<input name=\"action\" value=\"edit\" type=\"submit\" />";
    }
    echo "\n</form>";
    for($i = 0; $i < count($list); $i++) {
      if ("{$list[$i]['dbtype']}"!="id" && "{$list[$i]['private']}"=="n" && "$op_{$list[$i]['x']}"!="" && "${$list[$i]['x']}"!="") {
	if ($sometext[$list[$i]['x']]=="") $zzop="{$list[$i]['x']}='${$list[$i]['x']}'";
	elseif ($database_server=="postgresql" && $sometext[$list[$i]['x']]=="LIKE") $zzop="{$list[$i]['x']} LIKE '%${$list[$i]['x']}%'";
	elseif ($database_server=="postgresql" && $sometext[$list[$i]['x']]=="ILIKE") $zzop="{$list[$i]['x']} ILIKE '%${$list[$i]['x']}%'";
	elseif ($database_server=="mysql" && $sometext[$list[$i]['x']]=="LIKE") $zzop="BINARY {$list[$i]['x']} LIKE '%${$list[$i]['x']}%'";
	elseif ($database_server=="mysql" && $sometext[$list[$i]['x']]=="ILIKE") $zzop="{$list[$i]['x']} LIKE '%${$list[$i]['x']}%'";
	else $zzop="{$list[$i]['x']}".$sometext[$list[$i]['x']]."'${$list[$i]['x']}'";

	$query_where.="$zzop AND ";
      }
    }
    $query_where=substr($query_where, 0, -5);
    $query_free="WHERE ".$query_where;
  }
 }
/*********************************************************************************************/
if(!empty($maintable)) {
  require "$maintable";
 }
/*********************************************************************************************/
if(!isset($_SESSION['action']) || $action=="search" && empty($maintable)) { ?>

  <table cellspacing="0" cellpadding="0" width="100%" style="background-color:#efebe7; border-style:solid; border-width:1px; border-color:#cbc1b7;">
    <tr>
    <td style="width:5px;">&nbsp;</td>
				     <td>

				     <?php
				     echo "
<table cellspacing=\"0\" cellpadding=\"0\" style=\"width:100%\">
<tr class=\"tr-topic subtitle\">";
  for($i = 0; $i < count($list); $i++) require "$sovixinclude/common/order_by.inc";
  if ($_SESSION['login']=="y") echo "<td></td>";
  echo "</tr>";
  if (isset($_GET['order_by'])) $order_by=$_GET['order_by'];

  for($i = 0; $i < count($list); $i++) {
    if ("{$list[$i]['x']}"!="") {
      $query_select.="{$list[$i]['x']},";
    }
  }
  $query_select=substr($query_select, 0, -1);

  if ($_SESSION['login']=="y") unset($query_free);

  $query = "SELECT $query_select FROM $dbtable $query_free ORDER BY $order_by";

  if($database_server=="postgresql") $result = pg_query($query) or die('Query failed: ' . pg_last_error());
  elseif($database_server=="mysql") $result = mysql_query($query) or die('Query failed: ' . mysql_error());

  $counter=0;
  while ( $row = $fetch_array($result) ) {
    $counter++; if (is_float($counter/2)) $class = "white"; else $class = "grey";
    print "  <tr valign=\"top\" "; if ($stripe_color=="y") echo " class=\"$class\""; echo">\n";
    for($i = 0; $i < count($list); $i++){ if ("{$list[$i]['private']}"=="n" || $_SESSION['login']=="y") {
	if ("{$list[$i]['beg']}"!="") echo "{$list[$i]['beg']}"; elseif ($hide_[$list[$i]['x']]!="y") {
	  echo "    <td";
	  if ("{$list[$i]['x']}"==str_replace(" ASC", "", "$order_by") && is_float($counter/2) || "{$list[$i]['x']}"==str_replace(" DESC", "", "$order_by") && is_float($counter/2)) { if (is_float($counter/2)) echo " class=\"white-active\""; }

	  echo ">";
	  if ("{$list[$i]['link']}"!="") echo "<a href=\"{$list[$i]['beg_link']}".$row["{$list[$i]['link']}"]."{$list[$i]['end_link']}\">";

	  if ("{$list[$i]['dbtype']}"=="boolean" && $stripe_color=="y") {
	    echo "<span style=\"color:#";
	    if ($row["{$list[$i]['x']}"]=="t" || $row["{$list[$i]['x']}"]=="1") echo "166600";
	    elseif ($row["{$list[$i]['x']}"]=="f" || $row["{$list[$i]['x']}"]=="0") echo "c10000";
	    echo ';\">';
	    if ($row["{$list[$i]['x']}"]=="t" || $row["{$list[$i]['x']}"]=="1") echo "Yes"; elseif ($row["{$list[$i]['x']}"]=="f" || $row["{$list[$i]['x']}"]=="0") echo "No";
	    echo "</span>";
	  }
	  if ("{$list[$i]['showcontent']}"=="y" && "{$list[$i]['dbtype']}"!="boolean") echo $row["{$list[$i]['x']}"];
	  elseif ("{$list[$i]['dbtype']}"!="boolean") echo "{$list[$i]['showcontent']}";
	}

	if ("{$list[$i]['link']}"!="") echo "</a>";
	if ("{$list[$i]['end']}"!="") echo "{$list[$i]['end']}"; else echo "</td>\n";
    
      }
    }
    if ($_SESSION['login']=="y") {
      echo "\n<td>
<form method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"".$row["id"]."\" />
<input name=\"action\" value=\"edit\" type=\"submit\" />
<input name=\"action\" value=\"drop\" type=\"submit\" />
</form>
</td>";
    }
    echo "  </tr>\n";
  }
  if($database_server=="postgresql") {
    pg_free_result($result);
    pg_close($dbconn);
  }
  elseif($database_server=="mysql") {
    mysql_close($link);
  }

  echo "<form method=\"post\">\n  <tr valign=\"top\">\n";
  if ($_SESSION['login']=="y") echo "<td></td>";

  $add_td="y";
  for($i = 0; $i < count($list); $i++) {

    if ($add_td=="y" && "{$list[$i]['dbtype']}"!="id" && "{$list[$i]['private']}"=="n" && "{$list[$i]['beg']}"!="") {
      $add_td="n";
      echo "
<td style=\"padding-top: 3px; border-style:solid; border-width:1px 0px 0px 0px; border-color:#000000;\" colspan=\"1\">&nbsp;</td>";
    }


    if ("{$list[$i]['dbtype']}"!="id" && "{$list[$i]['private']}"=="n" && "{$list[$i]['beg']}"=="" && "{$list[$i]['end']}"=="") {

     
      if ($hide_[$list[$i]['x']]!="y") {
	echo "    <td style=\"padding-top: 3px; border-style:solid; border-width:1px 0px 0px 0px; border-color:#000000;\">\n";

	if ("{$list[$i]['showcontent']}"=="y") {

	  if ("{$list[$i]['dbtype']}"=="boolean") {
	    echo "      <select name=\"{$list[$i]['x']}\">
        <option value=\"\""; if ($action=="search" && "${$list[$i]['x']}"=="") echo " selected=\"selected\""; echo "></option>
        <option value=\"t\""; if ($action=="search" && "${$list[$i]['x']}"=="t" || $action=="search" && "${$list[$i]['x']}"=="1") echo " selected=\"selected\""; echo ">Y</option>
        <option value=\"f\""; if ($action=="search" &&  "${$list[$i]['x']}"=="f" || $action=="search" && "${$list[$i]['x']}"=="0") echo " selected=\"selected\""; echo ">N</option>
      </select>\n";
	  } else {
	    echo "      <select name=\"op_{$list[$i]['x']}\">
        <option value=\"empty\""; if ($action=="search" && "${$list[$i]['x']}"=="") echo " selected=\"selected\""; echo "></option>
        <option value=\"=\""; if ($action=="search" && $sometext[$list[$i]['x']]=="=") echo " selected=\"selected\""; echo ">=</option>
        <option value=\"!=\""; if ($action=="search" && $sometext[$list[$i]['x']]=="!=") echo " selected=\"selected\""; echo ">!=</option>
";
	    if ("{$list[$i]['dbtype']}"=="date" || "{$list[$i]['dbtype']}"=="time" || "{$list[$i]['dbtype']}"=="integer") {
	      echo "        <option value=\">\""; if ($action=="search" && $sometext[$list[$i]['x']]==">") echo " selected=\"selected\""; echo ">></option>
        <option value=\">=\""; if ($action=="search" && $sometext[$list[$i]['x']]==">=") echo " selected=\"selected\""; echo ">>=</option>
        <option value=\"<\""; if ($action=="search" && $sometext[$list[$i]['x']]=="<") echo " selected=\"selected\""; echo "><</option>
        <option value=\"<=\""; if ($action=="search" && $sometext[$list[$i]['x']]=="<=") echo " selected=\"selected\""; echo "><=</option>
";
	    }
	    if ("{$list[$i]['dbtype']}"=="text" || "{$list[$i]['dbtype']}"=="char" || "{$list[$i]['dbtype']}"=="varchar") {
	      echo "        <option value=\"LIKE\""; if ($action=="search" && $sometext[$list[$i]['x']]=="LIKE") echo " selected=\"selected\""; echo ">Like</option>
        <option value=\"ILIKE\""; if ($action=="search" && $sometext[$list[$i]['x']]=="ILIKE") echo " selected=\"selected\""; echo ">I-like</option>
";
	    }
	    echo "      </select><br />
      <input name=\"{$list[$i]['x']}\" type=\"";
	    if ("{$list[$i]['dbtype']}"!="boolean") echo "text\" size=\"8\"";
	    if ("{$list[$i]['dbtype']}"=="date") echo " maxlength=\"10\"";
	    elseif ("{$list[$i]['dbtype']}"=="time") echo " maxlength=\"8\"";
	    if ($action=="search" && "${$list[$i]['dbtype']}"!="boolean") echo " value=\""."${$list[$i]['x']}"."\"";
	    echo " />\n";
	  }
	}
	echo "    </td>\n";
      }
    }
  }
  echo "\n  </tr>\n</table>

<p></p>
<input type=\"hidden\" name=\"action\" value=\"search\" />
<input type='submit' value=\"Find\">
</form>
"; ?>

    </td>
	<td style="width:5px;">&nbsp;</td>
					 </tr>
					 </table>


					 <?php
					 if ($_SESSION['login']=="y") {
					   echo "
<p></p>
<form method=\"post\">
<input type=\"hidden\" name=\"action\" value=\"search\" />
<input type=\"hidden\" name=\"action\" value=\"insertnew\" />
<p></p>
<input value=\"Insert new\" type=\"submit\" />
</form>";
					 }
  echo "</div>";
 }
/*********************************************************************************************/
elseif ($action=="insertnew" || $action=="advancedsearch") {

  echo "<hr />
<h2>Insert new values</h2>

<form method=\"post\">
<input type=\"hidden\" name=\"action\" value=\"insert\" />
<input type=\"hidden\" name=\"new\" value=\"y\" />
<input type=\"hidden\" name=\"id\" value=\"".$row["id"]."\" />

<table>\n";

  for($i = 0; $i < count($list); $i++){ if ("{$list[$i]['dbtype']}"=="id" && $action=="update") {
      echo "  <tr>\n    <td>ID</td>\n    <td>$id</td>\n  </tr>";
    }
    elseif ("{$list[$i]['dbtype']}"!="id") {
      echo "  <tr valign=\"top\">\n    <td>{$list[$i]['y']}</td>\n    <td>";
      if ("{$list[$i]['dbtype']}"=="text") echo "<textarea rows=\"10\" name=\"{$list[$i]['x']}\">".$row["{$list[$i]['x']}"]."</textarea>";
      else {
	echo "<input type=\"";
	if ("{$list[$i]['dbtype']}"=="boolean") echo "checkbox";
	elseif ("{$list[$i]['dbtype']}"=="date" || "{$list[$i]['dbtype']}"=="time" || "{$list[$i]['dbtype']}"=="text") echo "text";
	echo "\" name=\"{$list[$i]['x']}\"";
	if ($action=="edit" && $row["{$list[$i]['x']}"]=="t" || $row["{$list[$i]['x']}"]=="1") echo "checked=\"checked\"";
	elseif ($action=="edit" && $row["{$list[$i]['dbtype']}"]!="boolean") echo " value=\"".$row["{$list[$i]['x']}"]."\"";
	elseif (!isset($action) && "{$list[$i]['value']}"=="t" || !isset($action) && "{$list[$i]['value']}"=="1") echo " checked=\"checked\"";
	elseif (!isset($action) && "{$list[$i]['x']}"=="date") echo " value=\"".date("Y-m-d")."\"";
	if ("{$list[$i]['dbtype']}"=="date") echo " maxlength=\"10\" size=\"10\"";
	elseif ("{$list[$i]['dbtype']}"=="time") echo " maxlength=\"8\" size=\"8\"";
	elseif ("{$list[$i]['maxlenght']}"!="") echo " maxlength=\"{$list[$i]['maxlenght']}\"";
	echo " />";
      }
      if ("{$list[$i]['require_value']}"=="y" && "{$list[$i]['dbtype']}"!="boolean") echo " [*]";
      if ("{$list[$i]['maxlenght']}"!="") echo " [Maxlength={$list[$i]['maxlenght']}]";
      echo "</td>\n  </tr>";
    }
  }
  echo "  <tr>\n  <td></td>\n    <td style=\"padding-top: 20px;\" ><input type=\"submit\" value=\"Add\"></td>\n  </tr>\n</table>\n</form>";
}
/*********************************************************************************************/
elseif ($action=="edit") {

  echo "
<hr />
<h2>Edit</h2>

<form method=\"post\">";

  for($i = 0; $i < count($list); $i++) {
    if ("{$list[$i]['x']}"!="") {
      $query_select2.="{$list[$i]['x']},";
    }
  }
  $query_select2=substr($query_select2, 0, -1);


  $query = "SELECT $query_select2 FROM $dbtable WHERE id=$id ORDER BY $order_by";

  if($database_server=="postgresql") $result = pg_query($query) or die('Query failed: ' . pg_last_error());
  elseif($database_server=="mysql") $result = mysql_query($query) or die('Query failed: ' . mysql_error());

  while ( $row = $fetch_array($result) ) {
    ?>

    <table>
      <?php for($i = 0; $i < count($list); $i++){ if ("{$list[$i]['x']}"=="id") { ?>
	<tr>
	  <td>ID</td>
	  <td><?php echo $id ?></td>
	  </tr>
	  <?php } else { ?>
	<tr valign="top">
	  <td><?php echo "{$list[$i]['y']}" ?></td>
	  <td><?php
	  if ("{$list[$i]['dbtype']}"=="text") echo "<textarea rows=\"10\" name=\"{$list[$i]['x']}\">".$row["{$list[$i]['x']}"]."</textarea>";
	  else {
	    echo "<input type=\"";
	    if ("{$list[$i]['dbtype']}"=="boolean") echo "checkbox";
	    else echo "text";
	    echo "\" name=\"{$list[$i]['x']}\"";


	    if ($action=="edit" && $row["{$list[$i]['x']}"]=="t" || $action=="edit" && $row["{$list[$i]['x']}"]=="1") echo "checked=\"checked\"";
	    elseif ($action=="edit" && $row["{$list[$i]['dbtype']}"]!="boolean") echo " value=\"".$row["{$list[$i]['x']}"]."\"";
	    elseif (!isset($action) && "{$list[$i]['value']}"=="t" || !isset($action) && "{$list[$i]['value']}"=="1") echo " checked=\"checked\"";
	    elseif (!isset($action) && "{$list[$i]['x']}"=="date") echo " value=\"".date("Y-m-d")."\"";

	    if ("{$list[$i]['dbtype']}"=="date") echo " maxlength=\"10\" size=\"10\"";
	    elseif ("{$list[$i]['dbtype']}"=="time") echo " maxlength=\"8\" size=\"8\"";
	    elseif ("{$list[$i]['maxlenght']}"!="") echo " maxlength=\"{$list[$i]['maxlenght']}\"";
	    echo " />";
	  }
	if ("{$list[$i]['require_value']}"=="y" && "{$list[$i]['dbtype']}"!="boolean") echo " [*]";
	if ("{$list[$i]['maxlenght']}"!="") echo " [Maxlength={$list[$i]['maxlenght']}]";
	?>

	  </td>
	      </tr>
	      <?php } } ?>

      <tr>
	 <td>  </td>
	 <td style="padding-top: 20px; " >
	 <input type="hidden" name="id" value="<?php echo $id; ?>" />
	 <input type='submit' name="action" value="update"></td>
	 </tr>
	 </table>

	 <?php
	 }

  if($database_server=="postgresql") {
    pg_free_result($result);
    pg_close($dbconn);
  }
  elseif($database_server=="mysql") {
    mysql_close($link);
  }
  ?>

    </form>
	<?php
	}
/*********************************************************************************************/
elseif ($action=="insert" || $action=="update") { ?>

  <hr />
    <h2><?php if ($action=="insert") echo "Insert"; elseif ($action=="update") echo "Update"; ?></h2>

												    <?php
												    echo "<ul>";
  for($i = 0; $i < count($list); $i++) if ("{$list[$i]['dbtype']}"!="id") {
      {
	echo "<li>";
	if($database_server=="postgresql") ${$list[$i]['x']}=pg_escape_string(stripslashes($_POST["{$list[$i]['x']}"]));
	elseif($database_server=="mysql") ${$list[$i]['x']}=mysql_escape_string(stripslashes($_POST["{$list[$i]['x']}"]));
	echo "${$list[$i]['x']}";
	if ("{$list[$i]['dbtype']}"=="boolean" && !empty(${$list[$i]['x']})) {
	  if($database_server=="postgresql") ${$list[$i]['x']}="t";
	  elseif ($database_server=="mysql") ${$list[$i]['x']}="1";
	}
	elseif ("{$list[$i]['dbtype']}"=="boolean" && empty(${$list[$i]['x']})) {
	  if($database_server=="postgresql") ${$list[$i]['x']}="f";
	  elseif ($database_server=="mysql") ${$list[$i]['x']}="0";
	}
	echo "{$list[$i]['y']}=${$list[$i]['x']}";
	if(${$list[$i]['x']}=="" && "{$list[$i]['require_value']}"=="y") { print" <span style=\"color:red;\">(empty)</span>"; $complete="n";}

	echo "</li>";
      }
    }
  echo "</ul>";

  if ($complete=="n") { ?>
    <form method="post">

      <?php if ($new=="y") { ?>
			     <input type="hidden" name="action" value="insertnew" />
			     <input value="Go back" type="submit" />
			     <?php } elseif ($action=="insert") { ?>
      <input type="hidden" name="id" value="<?php echo $id; ?>" />
					 <input name="action" value="edit" type="submit" />
					 <?php } ?>

				       </form>
					   <?php
					   }
  ?>

    <?php

	for($i = 0; $i < count($list); $i++) {
	  if ("{$list[$i]['dbtype']}"!="id") {
	    if ("{$list[$i]['require_value']}"=="n" || "{$list[$i]['require_value']}"=="y" && ${$list[$i]['x']}!="") {
	      $query_insert.="{$list[$i]['x']},";
	    }
	  }
	}
  $query_insert=substr($query_insert, 0, -1);

  for($i = 0; $i < count($list); $i++) {
    if ("{$list[$i]['dbtype']}"!="id") {
      if ("{$list[$i]['require_value']}"=="n" || "{$list[$i]['require_value']}"=="y" && ${$list[$i]['x']}!="") {
	if("${$list[$i]['x']}"=="") {
	  $query_values.="NULL,";
	}
	else {
	  $query_values.="'${$list[$i]['x']}',";
	}
      }
    }
  }
  $query_values=substr($query_values, 0, -1);

  for($i = 0; $i < count($list); $i++) {
    if ("{$list[$i]['dbtype']}"!="id") {
      if ("{$list[$i]['require_value']}"=="n" || "{$list[$i]['require_value']}"=="y" && ${$list[$i]['x']}!="") {
	if("${$list[$i]['x']}"=="") {
	  $query_update.="{$list[$i]['x']}=NULL,";
	}
	else {
	  $query_update.="{$list[$i]['x']}='${$list[$i]['x']}',";
	}
      }
    }
  }

  $query_update=substr($query_update, 0, -1);

  echo $query_update;

  if ($complete!="n") {
    if ($action=="insert") $query="INSERT INTO $dbtable ( $query_insert ) VALUES ( $query_values )";
    elseif ($action=="update") $query="UPDATE $dbtable SET $query_update WHERE id='$id'";

    if($database_server=="postgresql") $result = pg_query($query) or die('Query failed: ' . pg_last_error());
    elseif($database_server=="mysql") $result = mysql_query($query) or die('Query failed: ' . mysql_error());

    if($database_server=="postgresql") {
      pg_free_result($result);
      pg_close($dbconn);
    }
    elseif($database_server=="mysql") {
      mysql_close($link);
    }

    echo "<p></p>The data has been updated into the database.<br /><a href=\"".$_SERVER['PHP_SELF']."\">Go back</a>";
  }
}
/*********************************************************************************************/
elseif ($action=="drop") { ?>

  <hr />
    <h2>Drop</h2>

    <?php  
    $query = "DELETE FROM $dbtable WHERE id=$id"; 

  if($database_server=="postgresql") $result = pg_query($query) or die('Query failed: ' . pg_last_error());
  elseif($database_server=="mysql") $result = mysql_query($query) or die('Query failed: ' . mysql_error());

  if($database_server=="postgresql") {
    pg_free_result($result);
    pg_close($dbconn);
  }
  elseif($database_server=="mysql") {
    mysql_close($link);
  }

  echo "ID $id is droped from the database. <a href=\"".$_SERVER['PHP_SELF']."\">Go back</a>";
  ?>

    <?php } ?>
